﻿define([
// dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/topic",
    "dojo/when",

// dijit
    "dijit/Destroyable",

// epi
    "epi/_Module",
    "epi/dependency",
    "epi/routes",
    "epi-cms/store/CustomQueryEngine",

// epi-stackla
    "epi-stackla/ModuleSettings",

// resources
    "epi/i18n!epi/cms/nls/episerver.stackla.initModule",
],
function (
// dojo
    declare,
    lang,
    topic,
    when,

// dijit
    Destroyable,

// epi
    _Module,
    dependency,
    routes,
    CustomQueryEngine,

// epi-addons
    ModuleSettings,
    res
) {

    // module:
    //      epi-stackla/stacklamodule
    // summary:
    //      EPiServer Stackla main.
    // tags:
    //      public

    return declare([_Module, Destroyable], {

        _settings: null,

        // =======================================================================
        // Public, overrided stubs
        // =======================================================================

        constructor: function (/*Object*/settings) {

            this._settings = settings;
        },

        initialize: function () {
            // summary:
            //      Initialize module
            // tags:
            //      public, extensions

            this.inherited(arguments);

            declare.safeMixin(ModuleSettings, this._settings);
        },

        postscript: function () {
            this.inherited(arguments);
        }
    });

});