﻿<%@ Page Language="C#" Inherits="System.Web.Mvc.ViewPage<AccessTokenViewModel>" %>

<%@ Import Namespace="EPiServer.UGC.UI.Models" %>
<%@ Import Namespace="EPiServer.UGC.Core.Helpers" %>
<%@ Import Namespace="EPiServer.Shell.Web.Mvc.Html" %>
<%@ Import Namespace="EPiServer.Shell.UI" %>
<%@ Import Namespace="EPiServer.Shell.Web" %>
<%@ Import Namespace="EPiServer.Shell.Navigation" %>
<%@ Import Namespace="EPiServer.UGC.Core.Models" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title><%=Html.Translate("/episerver/stackla/authentication/title") %></title>
    <%= Page.ClientResources("StacklaResource") %>
</head>
<body>
    <script type="text/javascript">
        if (window.opener && window.opener.userAuthenticatedCallback) {
            // Will convert the given model object to Json data string.
            // The structure of the converted Json data string can be:
            //      {
            //          HttpStatusCode: [string],
            //          TechnicalMessage: [string],
            //          IsSuccess: [bool],
            //          AccessTokenResponse : {
            //              access_token: [string],
            //              refresh_token: [string],
            //              token_type: [string],
            //              expires_in: [number],
            //              error: [string],
            //              error_description: [string],
            //          }
            //      }
            window.opener.userAuthenticatedCallback(<%= (TempData["accessTokenViewModel"] as AccessTokenViewModel).ToJson() %>);
        }
        window.close();
    </script>
</body>
</html>
